void setup() {
  // 縦横1200x400のウインドウを作成する
  size( 1200, 400 );
  textSize( 30 );
  // 1秒に1回更新とする
  frameRate(1);
}

// f(x,n)を求める
float f( float x, int num ) {
  float ret = 1.0;
  // (-1)^numを先に計算しておく
  ret = ret * pow(-1, num);
  // x^num/num!を計算するとき，x^numで桁あふれしてしまう
  // なので，分母と分子をそれぞれ分解して計算しておこう
  // 例 num = 10のとき
  // (x/1) * (x/2) * (x/3) * ... * (x/10)
  for ( int i=1; i<=2*num; i++ ) {
    ret = ret * x / i;
  }
  return ret;
}

// Maclaurin(x,n)を求める
float Maclaurin( float x, int n ) {
  float retVal = 1;
  for ( int i=1; i<=n; i++ ) {
    retVal = retVal + f(x, i);
  }
  return retVal;
}

int number = 0;
void draw() {
  // 背景を白色で塗りつぶす
  background( 255 );
  // 線の太さは適当に３とする
  strokeWeight(3);
  // 軸を描く
  stroke( 0 );
  line(0, height/2, width, height/2);
  line(width/2, 0, width/2, height);

  fill( 0 );
  text( "n = " + number, 100, 50 );

  // -4PIから初めて4PIくらいまで描画してみる
  float x = -4*PI;
  while ( x < 4*PI ) {
    // (x*50, y*100)の所にsinxの値を描画してみる
    float y1 = cos(x);
    stroke(0, 0, 255);
    point( x*50 + width/2, height/2-y1*100 );

    // (x*50, y*100)の所にsinxの近似の値を描画してみる
    // numberはどの項まで対象とするかということ
    float y2 = Maclaurin(x, number);
    stroke( 255, 0, 0 );
    point( x*50 + width/2, height/2-y2*100 );

    // xの値を増やす
    x += 0.01;
  }

  // 20になったら０に戻そう！
  number++;
  if ( number > 20 ) {
    number = 0;
  }
}

